signature PLAYER = sig

    (* A player p is represented by a function. Given a previous
     * move m and total remaining thinking time t, p(m,t) returns
     * the next move of the player. *)
    type player = Types.move * Time.time -> Types.move

    (* Returns the name of the player. This should be of the form
       <netid1>-<netid2>_AI for tournament submissions *)
    val getName: unit -> string

    (* createPlayer(c,n,t) creates a new player at color c that
     * expects to play on an n x n board with total thinking
     * time t. Checks: n is odd, n >= 5, t>0. *)
    val createPlayer: Types.color -> int -> Time.time -> player

end

