structure Types = struct

    datatype color = BLACK | WHITE

    (* The contents of a board location. NONE indicates 
     * that no piece exists at that location *)
    type boardLoc = color option

    (* A coordinate (x,y) represents a location on the board.
     * x is the horizontal axis and y is the vertical axis.
     * Coordinates start at 0, so (0,0) is the upper-left
     * corner of the board *)
    type coordinate = int * int

    (* A move. Ordinarily just a Move(c) where a new piece 
     * is to be placed at c. "Human" tells the UI that it 
     * must get the move. "Start" is given to a player if 
     * the game has just started and it is the first to move. *)
    datatype move = Start | Move of coordinate | Human

end

