structure TestGUI :> sig val test:unit -> unit end = struct

    open TkTypes
    open SmlTk

    val mainID = newWinId()
    val entID1 = newWidgetId()

    (* Widgets in the window *)
    val lab = Label{widId=newWidgetId(), packings=[],
                    configs=[Text "Hello world"], bindings=[]}

    val input = let
                   fun endInput _ = changeTitle mainID (mkTitle(readTextAll entID1))
                in
                   Entry{widId=entID1, packings=[], configs=[Width 20],
                         bindings=[BindEv(KeyPress "Return",endInput)]}
                end

    val quit = let
                 fun stop _ = closeWindow mainID
               in
                 Button{widId=newWidgetId(), packings=[Side Bottom],
                         configs=[Text "Quit", Command stop],
                         bindings=[]}
               end

    (* Top frame conatins label and input box*)
    val topblock = Frame{widId=newWidgetId(), widgets=Pack [lab, input],
                         packings=[], configs=[], bindings=[]}

    (* Window conatins top frame and quit button*)
    val enterwin = {winId = mainID,
                    config = [WinTitle "Please enter name"],
                    widgets = Pack [topblock, quit],
                    bindings = [],
                    init = noAction}

    fun test () =
        ( SmlTk.init();
          startTcl [mkWindow enterwin]        (* showtime! *)
        )

end

